// NESColumns.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f NESColumnsps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "NESColumns.h"

#include "NESColumns_i.c"
#include "NESColExt.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_NESColExt, CNESColExt)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance, &LIBID_NESCOLUMNSLib);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow()
{
	return (_Module.GetLockCount() == 0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer()
{
	// On NT, add our extension to the list of approved extensions.
	if ((GetVersion() & 0x80000000) == 0)
	{
		CRegKey reg;
		LONG lRet;

		lRet = reg.Open(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved"), KEY_SET_VALUE);

		if (lRet != ERROR_SUCCESS)
			return E_ACCESSDENIED;

		TCHAR *value = _T("iNES Header Viewer Column Extension");
		lRet = reg.SetValue(_T("{C5820971-D905-4E90-8AD6-38283640F2E1}"), REG_SZ, value, (_tcslen(value) + 1) * sizeof(TCHAR));

		reg.Close();

		if ( ERROR_SUCCESS != lRet )
			return E_ACCESSDENIED;
	}

	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(false);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer()
{
	// On NT, remove our extension from the list of approved extensions.
	if ((GetVersion() & 0x80000000) == 0)
	{
		CRegKey reg;
		LONG lRet;

		lRet = reg.Open (HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved"), KEY_SET_VALUE);

		if (lRet == ERROR_SUCCESS)
		{
			reg.DeleteValue(_T("{C5820971-D905-4E90-8AD6-38283640F2E1}"));
			reg.Close();
		}
	}

	return _Module.UnregisterServer(false);
}
